package cn.com.infosec.jce.provider.fastparser;

import java.io.FileInputStream;
import java.util.Vector;

public class FX509CRL {
   private Item TBSCertList;
   private Item signatureAlgorithm;
   private Item signatureValue;
   private Item version;
   private Item signature;
   private Item issuer;
   private Item thisUpdate;
   private Item nextUpdate;
   private Item revokedCertificates;
   private Item crlExtensions;
   private Vector vsn;
   private byte[] input;

   public FX509CRL() {
      FX509CRL var10000 = this;
      FX509CRL var10001 = this;
      FX509CRL var10002 = this;
      FX509CRL var10003 = this;
      super();
      Item var1;
      var1 = new Item.<init>();
      var10003.revokedCertificates = var1;
      var1 = new Item.<init>();
      var10002.crlExtensions = var1;
      Vector var2;
      var2 = new Vector.<init>(0);
      var10001.vsn = var2;
      var10000.input = null;
   }

   public FX509CRL(byte[] input, Item it) {
      FX509CRL var10000 = this;
      FX509CRL var10003 = this;
      FX509CRL var10004 = this;
      FX509CRL var10005 = this;
      FX509CRL var10006 = this;
      super();
      Item var3;
      var3 = new Item.<init>();
      var10006.revokedCertificates = var3;
      var3 = new Item.<init>();
      var10005.crlExtensions = var3;
      Vector var4;
      var4 = new Vector.<init>(0);
      var10004.vsn = var4;
      var10003.input = null;
      int var5 = it.offset;
      int it1 = it.length;
      var10000.parse(input, var5, it1);
   }

   private void fetchSN(byte[] input, int offset, int length, Vector vsn) {
      Item var7;
      var7 = new Item.<init>();

      Item var6;
      for(int var5 = 0; var5 < length - 2; vsn.add(var6)) {
         Item var10000 = var6 = new Item;
         var6.<init>();
         DerUtil.computeOffset(input, var7, offset, var5);
         DerUtil.computeOffset(input, var6, offset, var7.offset);
         var5 = var7.offset + var7.length;
         var10000.offset += offset;
         if (DerUtil.debug) {
            DerUtil.printItem(input, var6);
         }
      }

   }

   static byte[] readCRL(String filename) {
      Exception var10000;
      label37: {
         boolean var10001;
         FileInputStream var7;
         try {
            var7 = new FileInputStream;
         } catch (Exception var5) {
            var10000 = var5;
            var10001 = false;
            break label37;
         }

         FileInputStream var1;
         FileInputStream var9 = var1 = var7;

         byte[] var8;
         try {
            var9.<init>(filename);
            var8 = new byte[var7.available()];
         } catch (Exception var4) {
            var10000 = var4;
            var10001 = false;
            break label37;
         }

         byte[] filename1 = var8;

         try {
            var9 = var1;
            var1.read(filename1);
         } catch (Exception var3) {
            var10000 = var3;
            var10001 = false;
            break label37;
         }

         try {
            var9.close();
            return var8;
         } catch (Exception var2) {
            var10000 = var2;
            var10001 = false;
         }
      }

      var10000.printStackTrace();
      return null;
   }

   public static void main(String[] args) {
      FX509CRL var1;
      var1 = new FX509CRL.<init>();

      for(int var2 = 0; var2 < args.length; ++var2) {
         System.out.println(args[var2]);
      }

      byte[] var3;
      byte[] var10002 = var3 = readCRL("D:/wangzongbin/PKITS_data/crls/BasicSelfIssuedOldKeySelfIssuedCertCRL.crl");
      System.out.println("\nFast:\n");
      var1.parse(var10002, 0, var10002.length);
      Vector var4 = var1.getRevokedCertificateSNs();

      int var6;
      for(int args1 = 0; args1 < var4.size(); args1 = var6) {
         System.out.print("SN[" + (var6 = args1 + 1) + "]=");
         DerUtil.printItem(var3, new Item((Item)var4.get(args1)));
      }

   }

   public void parse(byte[] input, int offset, int length) {
      this.input = input;
      Item length1;
      Item var10002 = length1 = new Item;
      length1.<init>();
      DerUtil.computeOffset(input, length1, offset, 0);
      int var4;
      length1.offset = (var4 = length1.offset) + offset;
      DerUtil.computeOffset(input, length1, offset, var4);
      var4 = length1.offset + length1.length;
      this.TBSCertList = new Item(length1);
      DerUtil.computeOffset(input, length1, offset, var4);
      int var10008 = length1.offset;
      var4 = var10008 + length1.length;
      length1.offset = var10008 + offset;
      this.signatureAlgorithm = new Item(length1);
      DerUtil.computeOffset(input, length1, offset, var4);
      var10002.offset += offset;
      this.signatureValue = new Item(length1);
      DerUtil.computeOffset(input, length1, offset, this.TBSCertList.offset - offset);
      if (length1.length == 1 && input[length1.offset] == 1) {
         Item var10003 = this.version = new Item(length1);
         var10003.offset += offset;
         DerUtil.computeOffset(input, length1, offset, length1.offset + length1.length);
      }

      int var11 = length1.offset;
      var4 = var11 + length1.length;
      length1.offset = var11 + offset;
      this.signature = new Item(length1);
      if (DerUtil.debug) {
         System.out.println("signature:");
         DerUtil.printItem(input, this.signature);
      }

      DerUtil.computeOffset(input, length1, offset, var4);
      var11 = length1.offset;
      var4 = var11 + length1.length;
      length1.offset = var11 + offset;
      this.issuer = new Item(length1);
      if (DerUtil.debug) {
         System.out.println("issuer:");
         DerUtil.printItem(input, this.issuer);
      }

      DerUtil.computeOffset(input, length1, offset, var4);
      var11 = length1.offset;
      var4 = var11 + length1.length;
      length1.offset = var11 + offset;
      this.thisUpdate = new Item(length1);
      if (DerUtil.debug) {
         System.out.println("thisUpdate:");
         DerUtil.printItem(input, this.thisUpdate);
      }

      Item var5;
      int var10;
      if (var4 <= (var10 = (var5 = this.TBSCertList).offset + var5.length - 1)) {
         DerUtil.computeOffset(input, length1, offset, var4);
         var11 = length1.offset;
         var4 = var11 + length1.length;
         length1.offset = var11 + offset;
         this.nextUpdate = new Item(length1);
         if (DerUtil.debug) {
            System.out.println("nextUpdate:");
            DerUtil.printItem(input, this.nextUpdate);
         }

         if (var4 < var10 && (input[var4] & 255) != 160) {
            DerUtil.computeOffset(input, length1, offset, var4);
            var11 = length1.offset;
            var4 = var11 + length1.length;
            length1.offset = var11 + offset;
            this.revokedCertificates = new Item(length1);
            if (DerUtil.debug) {
               System.out.println("revokedCertificates:");
            }

            var10002 = this.revokedCertificates;
            int var6 = var10002.offset;
            int var7 = var10002.length;
            Vector var8 = this.vsn;
            this.fetchSN(input, var6, var7, var8);
         }

         if (var4 < var10 && (input[var4] & 255) == 160) {
            DerUtil.computeOffset(input, length1, offset, var4);
            length1.offset += offset;
            this.crlExtensions = new Item(length1);
            if (DerUtil.debug) {
               System.out.println("crlExtensions:");
               DerUtil.printItem(input, this.crlExtensions);
            }
         }

      }
   }

   public byte[] getItemData(Item item) {
      if (item == null) {
         return new byte[0];
      } else {
         int var2;
         byte[] var3;
         byte[] var10000 = var3 = new byte[var2 = item.length];
         System.arraycopy(this.input, item.offset, var3, 0, var2);
         return var10000;
      }
   }

   public byte[] getItemDataAndTag(Item item) {
      if (item == null) {
         return new byte[0];
      } else {
         int var2;
         int var3;
         byte[] var4;
         byte[] var10000 = var4 = new byte[(var2 = item.length) + (var3 = item.tagsize)];
         byte[] var10001 = this.input;
         int var5 = item.offset - var3;
         int item1 = var2 + var3;
         System.arraycopy(var10001, var5, var4, 0, item1);
         return var10000;
      }
   }

   public final Item getTBSCertList() {
      return this.TBSCertList;
   }

   public final Item getSignature() {
      return this.signature;
   }

   public final Item getIssuer() {
      return this.issuer;
   }

   public final Item getThisUpdate() {
      return this.thisUpdate;
   }

   public final Item getNextUpdate() {
      return this.nextUpdate;
   }

   public final Vector getRevokedCertificateSNs() {
      return this.vsn;
   }

   public final Item getSignatureAlgorithm() {
      return this.signatureAlgorithm;
   }

   public final Item getSignatureValue() {
      return this.signatureValue;
   }
}
